- Qt 5.15
- Qt Core
- C++ Classes
- QRecursiveMutex
- Qt 5.15.19 Reference Documentation

# QRecursiveMutex Class

The QRecursiveMutex class provides access serialization between threads. More...

Header: | #include <QRecursiveMutex>
qmake: | QT += core
Since: | Qt 5.14
Inherits: | QMutex (private)

This class was introduced in Qt 5.14.

- List of all members, including inherited members

Note: All functions in this class are thread-safe.

## Public Functions

| QRecursiveMutex()
| ~QRecursiveMutex()

## Detailed Description

The QRecursiveMutex class is a mutex, like QMutex, with which it is API-compatible. It differs from QMutex by accepting lock() calls from the same thread any number of times. QMutex would deadlock in this situation.

QRecursiveMutex is much more expensive to construct and operate on, so use a plain QMutex whenever you can. Sometimes, one public function, however, calls another public function, and they both need to lock the same mutex. In this case, you have two options:

- Factor the code that needs mutex protection into private functions, which assume that the mutex is held when they are called, and lock a plain QMutex in the public functions before you call the private implementation ones.
- Or use a recursive mutex, so it doesn't matter that the first public function has already locked the mutex when the second one wishes to do so.

See also QMutex, QMutexLocker, QReadWriteLock, QSemaphore, and QWaitCondition.

## Member Function Documentation

### QRecursiveMutex::QRecursiveMutex()

Constructs a new recursive mutex. The mutex is created in an unlocked state.

See also lock() and unlock().

### QRecursiveMutex::~QRecursiveMutex()

Destroys the mutex.

Warning: Destroying a locked mutex may result in undefined behavior.